
#define gui_set_text(X,Y) \
 do {typeof(X)* Z= &(X); Z->cls->set_text(Z,Y);} while(0)
#define gui_get_text(X) \
 ({typeof(X)* _Z= &(X); char *_K= _Z->cls->get_text(_Z); _K;})
#define gui_set_value(X,Y) \
 do {typeof(X)* Z= &(X); Z->cls->set_value(Z,Y);} while(0)

#define gui_list_append(X, ...) \
 do { typeof(X)* Z= &(X); Z->cls->append_item(Z, __VA_ARGS__ ); } while(0)

#define gui_list_get_selected(X,Y) \
 ({ typeof(X)* Z= &(X); int _K= Z->cls->get_selected(Z,Y); _K; })

#define gui_print(X, ...) \
 do { typeof(X)* Z= &(X); Z->cls->print(Z, __VA_ARGS__ ); } while(0)

#define gui_clear(X) \
 do { typeof(X)* Z= &(X); Z->cls->clear(Z); } while(0)

 

#ifndef gui_set_all_text
#define gui_set_all_text(X, ... ) ({typeof(X)* _Z= &(X);_Z->cls->set_all_text(_Z, __VA_ARGS__);})
#endif



 
typedef struct gui_radio_group gui_radio_group_t;

typedef struct {
  void (*set_value)(struct gui_radio_group *, int);
  void (*get_value)(struct gui_radio_group*, int *);
} gui_radio_group_class_t;

struct gui_radio_group
{
  gui_radio_group_class_t *cls;
  void *widget;
};


typedef struct gui_button gui_button_t;

typedef struct {
  void (*set_text)(struct gui_button *,const char *);
} gui_button_class_t;

struct gui_button {
  gui_button_class_t *cls;
  void *widget;
};



 typedef struct gui_newbutton gui_newbutton_t;
 typedef struct 
 {
   

 int (*set_all_text)(gui_newbutton_t *    , char*);


 } gui_newbutton_class_t;

 struct gui_newbutton {
   gui_newbutton_class_t *cls;
   void *widget;
 };


typedef struct gui_label gui_label_t;

typedef struct {
  void (*set_text)(struct gui_label *,char *);
} gui_label_class_t;

struct gui_label {
  gui_label_class_t *cls;
  void *widget;
};


typedef struct gui_text_entry gui_text_entry_t;

typedef struct {
  void (*set_text)(struct gui_text_entry *,char *);
  char* (*get_text)(struct gui_text_entry *);
} gui_text_entry_class_t;

struct gui_text_entry {
  gui_text_entry_class_t *cls;
  void *widget;
};


typedef struct gui_spinner gui_spinner_t;

typedef struct {
  void (*set_value)(struct gui_spinner *,int );
  void (*get_value)(struct gui_spinner *,int *);
} gui_spinner_class_t;

struct gui_spinner {
  gui_spinner_class_t *cls;
  void *widget;
};



typedef struct gui_intlist gui_intlist_t;

typedef struct {
   int (*get_selected)(gui_intlist_t *, int *);
   int (*select_item)(gui_intlist_t *, int, int);
   void (*clear_selection)(gui_intlist_t *);
   void (*append_item)(gui_intlist_t *, const char *,int);
   void (*prepend_item)(gui_intlist_t *, const char *,int);
   void (*insert_item)(gui_intlist_t *, int, const char *,int);
   void (*remove)(gui_intlist_t *, int);
   void (*clear)(gui_intlist_t *);
} gui_intlist_class_t;


struct gui_intlist {
  gui_intlist_class_t *cls;
  void *widget;
};



typedef struct gui_sslist gui_sslist_t;

typedef struct {
   int (*get_selected)(gui_sslist_t *, char**);
   void (*append_item)(gui_sslist_t *, const char *);
   void (*prepend_item)(gui_sslist_t *, const char *);
   void (*insert_item)(gui_sslist_t *, const char* , const char *);
} gui_sslist_class_t;

struct gui_sslist {
  gui_sslist_class_t *cls;
  void *widget;
};




typedef struct gui_slist gui_slist_t;

typedef struct {
   int  (*get_selected)(gui_slist_t *, char**);
   void (*append_item)(gui_slist_t *, const char *,const char*);
   void (*prepend_item)(gui_slist_t *, const char *,const char*);
   void (*insert_item)(gui_slist_t *, const char* , const char *,const char*);
   void (*remove)(gui_slist_t *,const char *);
} gui_slist_class_t;

struct gui_slist {
  gui_slist_class_t *cls;
  void *widget;
};



 typedef struct gui_message_console gui_message_console_t;

 typedef struct {
    void (*print)(gui_message_console_t *,const char *,...);
    void (*clear)(gui_message_console_t *);
    void (*append)(gui_message_console_t *, const char *, size_t);
 } gui_message_console_class_t;

 struct gui_message_console {
    gui_message_console_class_t *cls;
    void *widget;
 };




typedef struct gui_dir_list gui_dir_list_t;

typedef struct {
   int (*get_current)(gui_dir_list_t *, const char **, int *);
   void (*set_current_file)(gui_dir_list_t* , const char*);
   void (*set_current_dir)(gui_dir_list_t* , const char*);
} gui_dir_list_class_t;

struct gui_dir_list
{
   gui_dir_list_class_t *cls;
   void *widget;
};




typedef struct gui_file_list gui_file_list_t;

typedef struct {
   int (*get_current)(gui_file_list_t *, const char **, int *);
   void (*set_current_file)(gui_file_list_t* , const char*);
   void (*set_current_dir)(gui_file_list_t* , const char*);
   void (*get_current_dir)(gui_file_list_t* , const char**);
} gui_file_list_class_t;

struct gui_file_list
{
   gui_file_list_class_t *cls;
   void *widget;
};



#ifdef __cplusplus
extern "C" {
#endif

void gui_init(int *argc,char **argv);
void gui_run();
void gui_flush();

#ifdef __cplusplus
}
#endif
 

typedef struct {
  void *self;
   gui_radio_group_t radio1;

 gui_button_t cool_button;

 gui_button_t foo_button;

 gui_newbutton_t allnew;

 

 

 

 

 gui_text_entry_t source_dir;

 

 

 

 


  gui_intlist_t numbers;

 


  gui_sslist_t strings;

 


  gui_slist_t string_keys;

 



 gui_message_console_t econ;

 
  gui_dir_list_t dirs;

 
  gui_file_list_t files;


 void* textedit;


 void* selfbutton;


} gui_testmain_t;

#ifdef __cplusplus
extern "C" {
#endif

gui_testmain_t *gui_c_testmain();

#ifdef __cplusplus
}
#endif





#define gui_get_value(X, ...) do { typeof(X)* _Z= &(X); _Z->cls->get_value(_Z, __VA_ARGS__ ); } while(0)

 #define gui_execute(X) ({typeof(X)* _Z= &(X); _Z->cls->execute(_Z); })

#define gui_close(X) do { typeof(X)* _Z= &(X); _Z->cls->close(_Z); } while(0)

#define gui_get_current(X, ...) ({ typeof(X)* _Z= &(X); _Z->cls->get_current(_Z, __VA_ARGS__ ); })
#define gui_set_current_file(X, ...) do { typeof(X)* _Z= &(X); _Z->cls->set_current_file(_Z, __VA_ARGS__ ); } while(0)

#define gui_set_current_dir(X, ...) do { typeof(X)* _Z= &(X); _Z->cls->set_current_dir(_Z, __VA_ARGS__ ); } while(0)

#define gui_append(X, ...) do { typeof(X)* _Z= &(X); _Z->cls->append(_Z, __VA_ARGS__ ); } while(0)

#define gui_remove(X, ...) do { typeof(X)* _Z= &(X); _Z->cls->remove(_Z, __VA_ARGS__ ); } while(0)

#define gui_clear_selection(X) do { typeof(X)* _Z= &(X); _Z->cls->clear_selection(_Z); } while(0)

#define gui_select_item(X, ...) do { typeof(X)* _Z= &(X); _Z->cls->select_item(_Z, __VA_ARGS__ ); } while(0)


