#line 234 "/home/dodo/SFP/fxform-1.2/src/main.u"

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "template.h"
#include "parse.h"

#line 312 "/home/dodo/SFP/fxform-1.2/src/main.u"

typedef struct strnode { struct strnode *next; char *data; } strlist_t;

#line 316 "/home/dodo/SFP/fxform-1.2/src/main.u"

static strlist_t *verbs;

#line 243 "/home/dodo/SFP/fxform-1.2/src/main.u"
int no_lines;
#line 19 "main.c"

static char *strip_quotes(char *str);
static void write_file(char *fn,char *dfn, tpl_t *contents);
static void insert_verbs(tpl_t *dest);
#line 41 "/home/dodo/SFP/fxform-1.2/src/main.u"

tpl_t *p_main_window(parser_t *P);
tpl_t *p_dialog(parser_t *P);
tpl_t *define_widget(parser_t *P);

#line 250 "/home/dodo/SFP/fxform-1.2/src/widget_parser.u"

#line 31 "main.c"


static void parse_file(char *fn)
{
   char *code_file=0, *header_file= 0;
   parser_t *P= parser_new(fn);
   tpl_t *form_code;
   tpl_t *top_header= tpl_new(
"\n"
"#define gui_set_text(X,Y) \134\n"
" do {typeof(X)* Z= &(X); Z->cls->set_text(Z,Y);} while(0)\n"
"#define gui_get_text(X) \134\n"
" ({typeof(X)* _Z= &(X); char *_K= _Z->cls->get_text(_Z); _K;})\n"
"#define gui_set_value(X,Y) \134\n"
" do {typeof(X)* Z= &(X); Z->cls->set_value(Z,Y);} while(0)\n"
"\n"
"#define gui_list_append(X, ...) \134\n"
" do { typeof(X)* Z= &(X); Z->cls->append_item(Z, __VA_ARGS__ ); } while(0)\n"
"\n"
"#define gui_list_get_selected(X,Y) \134\n"
" ({ typeof(X)* Z= &(X); int _K= Z->cls->get_selected(Z,Y); _K; })\n"
"\n"
"#define gui_print(X, ...) \134\n"
" do { typeof(X)* Z= &(X); Z->cls->print(Z, __VA_ARGS__ ); } while(0)\n"
"\n"
"#define gui_clear(X) \134\n"
" do { typeof(X)* Z= &(X); Z->cls->clear(Z); } while(0)\n"
"\n"
" <verbs>\n"
"\n"
"\n"
" <library_interface>\n"
"#ifdef __cplusplus\n"
"extern \042C\042 {\n"
"#endif\n"
"\n"
"void gui_init(int *argc,char **argv);\n"
"void gui_run();\n"
"void gui_flush();\n"
"\n"
"#ifdef __cplusplus\n"
"}\n"
"#endif\n"
" <top_level_interface>\n"
"\n"
"\n"
"\n"
"#define gui_get_value(X, ...) do { typeof(X)* _Z= &(X); _Z->cls->get_value(_Z, __VA_ARGS__ ); } while(0)\n"
"\n"
" #define gui_execute(X) ({typeof(X)* _Z= &(X); _Z->cls->execute(_Z); })\n"
"\n"
"#define gui_close(X) do { typeof(X)* _Z= &(X); _Z->cls->close(_Z); } while(0)\n"
"\n"
"#define gui_get_current(X, ...) ({ typeof(X)* _Z= &(X); _Z->cls->get_current(_Z, __VA_ARGS__ ); })\n"
"#define gui_set_current_file(X, ...) do { typeof(X)* _Z= &(X); _Z->cls->set_current_file(_Z, __VA_ARGS__ ); } while(0)\n"
"\n"
"#define gui_set_current_dir(X, ...) do { typeof(X)* _Z= &(X); _Z->cls->set_current_dir(_Z, __VA_ARGS__ ); } while(0)\n"
"\n"
"#define gui_append(X, ...) do { typeof(X)* _Z= &(X); _Z->cls->append(_Z, __VA_ARGS__ ); } while(0)\n"
"\n"
"#define gui_remove(X, ...) do { typeof(X)* _Z= &(X); _Z->cls->remove(_Z, __VA_ARGS__ ); } while(0)\n"
"\n"
"#define gui_clear_selection(X) do { typeof(X)* _Z= &(X); _Z->cls->clear_selection(_Z); } while(0)\n"
"\n"
"#define gui_select_item(X, ...) do { typeof(X)* _Z= &(X); _Z->cls->select_item(_Z, __VA_ARGS__ ); } while(0)\n"
"\n"
"\n"

   );
   tpl_t *top_code= tpl_new(
"\n"
"#include <stdlib.h>\n"
"#include <stdio.h>\n"
"#include <stdarg.h>\n"
"#include <string.h>\n"
"#include <limits.h>\n"
"#include <fx.h>\n"
"#include <stdint.h>\n"
"#include <FXPNGIcon.h>\n"
"\n"
"static int app_created;\n"
"\n"
"$header_include\n"
"$header\n"
"\n"
" <library_code>\n"
" <generated_commands>\n"
" <library_objects>\n"
" <form_types>\n"
" <top_level_code>\n"
"\n"
"static FXApp *app;\n"
"\n"
"void gui_init(int *argc,char **argv)\n"
"{\n"
"  app= new FXApp(\042YAK\042, \042KUT\042);\n"
"  app->init(*argc, argv);\n"
"  app->create();\n"
"  <GUI_object_creation>\n"
"  app_created= 1;\n"
"}\n"
"\n"
"void gui_run()\n"
"{\n"
"  app->run();\n"
"}\n"
"\n"
"void gui_flush()\n"
"{\n"
"  app->runWhileEvents();\n"
"}\n"
"\n"
"$footer\n"
"\n"

  );

  while(1) {
   char *kw;
   kw= parse_ident_or_eof(P);
   if (!kw) break;
   if (!strcmp(kw,"header_file")) {        char *  K= parse_strlit(P);
        header_file= strip_quotes(K);  continue; }

   if (!strcmp(kw,"code_file")) {        char *  K= parse_strlit(P);
        code_file= strip_quotes(K);  continue; }

   if (!strcmp(kw,"no_lines")) {  no_lines=1;  continue; }

   if (!strcmp(kw,"main_window")) {  
        form_code= p_main_window(P);
        tpl_relocations_known_only(top_header, form_code);
        tpl_relocations(top_code, form_code);
    continue; }

   if (!strcmp(kw,"dialog")) {  
        form_code= p_dialog(P);
        tpl_relocations_known_only(top_header, form_code);
        tpl_relocations(top_code, form_code);
    continue; }

   if (!strcmp(kw,"define_widget")) {  define_widget(P);  continue; }

   if (!strcmp(kw,"header")) {  tpl_replace(top_code,"$header", parse_cpp(P));  continue; }

   if (!strcmp(kw,"footer")) {  tpl_replace(top_code,"$footer", parse_cpp(P));  continue; }

  }

  if (!header_file) header_file= "gui.h";
  char buf[200];
  snprintf(buf,200, "#include \"%s\"\n", header_file);
  tpl_replace(top_code, "$header_include", strdup(buf));

  insert_verbs(top_header);

  tpl_replace(top_code, "$footer", "");
  
  write_file(code_file,"gui.cc", top_code);
  write_file(header_file,"gui.h", top_header);
}

#line 257 "/home/dodo/SFP/fxform-1.2/src/widget_parser.u"

#line 109 "/home/dodo/SFP/fxform-1.2/src/main.u"

static char *strip_quotes(char *str)
{
  char *x;
  str= strdup(str);
  if (str[0]=='"') memmove(str, str+1, strlen(str+1)+1);
  x= strchr(str,'"');
  if (x) x[0]= 0;
  return str;
}

static void write_file(char *fn,char *dfn, tpl_t *contents)
{
  char *R;
  if (!fn) fn= dfn;
  R= tpl_to_str(contents);
  FILE *f= fopen(fn,"w");
  if (!f) exit(fprintf(stderr,"can not open %s for writing.\n", fn));
  fwrite(R, 1, strlen(R),f);
  fclose(f);
  free(R);
}
#line 333 "/home/dodo/SFP/fxform-1.2/src/main.u"

static void insert_verbs(tpl_t *dest)
{
  tpl_t *T;
  strlist_t *V;

  for(V=verbs;V;V=V->next)
  {
    T= tpl_new(
#line 228 "main.c"
"\n"
"@verbs\n"
"\n"
"#ifndef $extern_name\n"
"#define $extern_name(X, ... ) ({typeof(X)* _Z= &(X);_Z->cls->$name(_Z, __VA_ARGS__);})\n"
"#endif\n"

#line 345 "/home/dodo/SFP/fxform-1.2/src/main.u"
    );
    tpl_replace(T,"$name", V->data);
    char buf[2000];
    sprintf(buf,"gui_%s",V->data);
    tpl_replace(T,"$extern_name", strdup(buf));
    tpl_relocations(dest, T);
  }
}

#line 320 "/home/dodo/SFP/fxform-1.2/src/main.u"

void define_verb(char *name)
{
  strlist_t *V;
  for(V=verbs;V;V=V->next)
    if (!strcmp(V->data,name)) return ;
  V= malloc(sizeof(*V));
  V->next= verbs;
  V->data= strdup(name);
  verbs= V;
}

#line 6 "/home/dodo/SFP/fxform-1.2/src/main.u"

int main(int argc,char **argv)
{
  int i;
  for(i=1;i<argc;i++)
    if (!strcmp(argv[i], "-v")) {
      printf("fxforms-1.2 2012-01-06 Copyright Sukru Cinar\n"
             "This program is distributed under the GPL v3 and\n"
             "there is no warranty, even for fitness for a\n"
             "particular purpose. See the file LICENSING for\n"
             "details.\n");
      return 0;
    } else if (!strcmp(argv[i], "-h")) {
      printf("usage: fxforms inputfile\n");
      return 0;
    }
  if (argc!=2) {
     fprintf(stderr,"usage: fxform inputfile\n");
     return 1;
  }
  parse_file(argv[1]);
  return 0;
}
#line 252 "/home/dodo/SFP/fxform-1.2/src/main.u"


