#line 254 "/home/dodo/SFP/fxform-1.2/src/w_user.u"

#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include "template.h"
#include "parse.h"

#line 43 "/home/dodo/SFP/fxform-1.2/src/w_user.u"

enum pro_kind { pro_int, pro_string, pro_ident,
                pro_flag, pro_color, pro_font };

typedef struct pro {
  struct pro *next;
  char *name;
  enum pro_kind kind;
} property_t;

#line 58 "/home/dodo/SFP/fxform-1.2/src/w_user.u"

typedef struct sig {
  struct sig *prev, *next;
  char *name;
  char *sel_prefix;
} signal_t;
 
#line 28 "/home/dodo/SFP/fxform-1.2/src/w_user.u"

typedef struct userwidget {
  struct userwidget *next;
  char *widget_name;
  tpl_t *library_code;
  char *widget_code;
  int library_code_printed;
  property_t *properties;
  signal_t *signals;
} user_widget_t;

#line 456 "/home/dodo/SFP/fxform-1.2/src/w_user.u"

typedef struct {
  char *cls, *name; enum pro_kind kind;
} common_property_t;

#line 69 "/home/dodo/SFP/fxform-1.2/src/w_user.u"

static user_widget_t *user_widgets;

#line 347 "/home/dodo/SFP/fxform-1.2/src/w_user.u"

void define_verb(char*);

#line 54 "w_user.c"

tpl_t *parse_user_widget(parser_t *P, char *name);
static tpl_t* parse_widget(parser_t *P, user_widget_t *uw);
static void parse_command(parser_t *P, tpl_t *lib);
static char *parse_type(parser_t *P, char *name);
static void parse_font_and_replace(char *pfx,parser_t *P,tpl_t *T);
static int insert_common_properties(user_widget_t *uw, char *name);
static void parse_common_properties(user_widget_t *uw, parser_t *P);
#line 162 "/home/dodo/SFP/fxform-1.2/src/w_user.u"

tpl_t *parse_user_widget(parser_t *P, char *name)
{
  user_widget_t *uw;
  for(uw=user_widgets;uw;uw=uw->next)
    if (!strcmp(name, uw->widget_name))
      return parse_widget(P, uw);
  return 0;
}

#line 173 "/home/dodo/SFP/fxform-1.2/src/w_user.u"

static tpl_t* parse_widget(parser_t *P, user_widget_t *uw)
{
  char buf[2000];
  char *kw;
  tpl_t *T;
  property_t *pro; signal_t *sig;
  char *objid= 0;

  T= tpl_new(uw->widget_code);
  parse_lcurly(P);
again:
  kw= parse_ident_or_rcurly(P);
  if (!kw) goto done;
  for(pro=uw->properties;pro;pro=pro->next)
    if (!strcmp(pro->name,kw))
      goto do_property;
  for(sig=uw->signals;sig;sig=sig->next)
    if (!strcmp(sig->name,kw))
      goto do_signal;
  p_error(P,0,"unknown keyword '%s'\n", kw);
done:
  if (objid && !uw->library_code_printed)
  {
    if (uw->library_code) tpl_append(T, uw->library_code);
    uw->library_code_printed= 1;
  }
  if (objid)
  {
    char g[2000];
    tpl_t *export= tpl_new(
#line 105 "w_user.c"
"\n"
"@form_widget_declarations $widget_struct_t $objid;\n"
"\n"
"@form_widget_export \n"
"  ifo->$objid.widget= ffo->$objid;\n"
"  ifo->$objid.cls= & $class_object;\n"

#line 207 "/home/dodo/SFP/fxform-1.2/src/w_user.u"
    );
      sprintf(g,"gui_%s_class", uw->widget_name);
    tpl_replace(export, "$class_object", strdup(g));
    tpl_replace(export, "$objid", objid);
      sprintf(g,"gui_%s_t", uw->widget_name);
    tpl_replace(export, "$widget_struct_t", strdup(g));
    tpl_append(T, export);
  }
  tpl_builtin(T);
  return T;
do_property:
  if (!strcmp(pro->name,"objid")) 
  {
    objid= parse_ident(P);
    tpl_replace(T, "$objid", objid);
    goto again;
  }
  sprintf(buf,"$%s",kw);
  switch(pro->kind)
  {
  case pro_int: tpl_replace_i(T,buf, parse_int(P)); goto again;
  case pro_string: tpl_replace(T,buf, parse_strlit(P)); goto again;
   // FIXME: how useful is this?
  case pro_ident: tpl_replace(T, buf, parse_ident(P)); goto again;
  case pro_flag: tpl_replace(T, buf, "Y"); goto again;
  case pro_color: tpl_replace(T, buf, parse_color(P)); goto again;
  case pro_font: parse_font_and_replace(kw,P,T); goto again;
  }
  p_error(P,0,"bad property type for %s.\n", kw);
  return 0;
do_signal:
  sprintf(buf,"$%s",kw);
  tpl_replace(T, buf, parse_cpp(P));
  goto again;
}

#line 309 "/home/dodo/SFP/fxform-1.2/src/w_user.u"

static void parse_command(parser_t *P, tpl_t *lib)
{
  char *name;
  char *type;
  char *argname;
  tpl_t *ct= tpl_new(
#line 157 "w_user.c"
"\n"
"@generated_commands\n"
"\n"
" static $return_type $G_func($widget_struct_t *object <arguments>)\n"
" {\n"
"    $code\n"
" }\n"
" \n"
"@command_declarations\n"
"\n"
" $return_type (*$command_name)($widget_struct_t * <argument_types>);\n"
"\n"
"@command_assignments\n"
" $G_func,\n"
"\n"
"\n"

#line 319 "/home/dodo/SFP/fxform-1.2/src/w_user.u"
  );
  name= parse_ident(P);
  if (strcmp(parse_ident(P),"returns"))
      p_error(P,0, "keyword 'returns' was expected.\n");

  type= parse_type(P,"return type");
  tpl_replace(ct, "$return_type", type);

  parse_lcurly(P);
  while((argname=parse_ident_or_rcurly(P)))
  {
    tpl_t *at= tpl_new("@arguments        , $type $name"
                       "@argument_types   , $type");
    type= parse_type(P, argname);
    tpl_replace(at,"$type", type);
    tpl_replace(at,"$name", argname);
    tpl_relocations(ct, at);
  }

  tpl_replace(ct, "$code", parse_cpp(P));
  tpl_replace(ct, "$command_name", name);
  tpl_builtin(ct);
  tpl_remove_targets(ct);

  tpl_relocations(lib, ct);
  define_verb(name);
}
#line 368 "/home/dodo/SFP/fxform-1.2/src/w_user.u"

static char *parse_type(parser_t *P, char *name)
{
  char *type= parse_ident(P);
  if (!strcmp(type,"int")) return "int";
  else if (!strcmp(type,"float")) return "double";
  else if (!strcmp(type,"string")) return "char*";
  else if (!strcmp(type,"int_array")) return "int*";
  else if (!strcmp(type,"float_array")) return "double*";
  else if (!strcmp(type,"string_array")) return "char**";
  else if (!strcmp(type,"ptr")) return "void*";
  p_error(P,0,"unknown type '%s' for '%s'\n", type, name);
  return 0;
}


#line 391 "/home/dodo/SFP/fxform-1.2/src/w_user.u"

static void parse_font_and_replace(char *pfx,parser_t *P,tpl_t *T)
{
  static char * font_style_keywords[][3]= 
  {
  { "reverse_oblique", "slant", "ReverseOblique" },
  { "reverse_italic" , "slant", "ReverseItalic" },
  { "no_slant"       , "slant", "Straight" },
  { "italic"         , "slant", "Italic" },
  { "oblique"        , "slant", "Oblique" },

  { "thin"           , "weight", "Thin" },
  { "extra_light"    , "weight", "ExtraLight" },
  { "light"          , "weight", "Light" },
  { "normal_weight"  , "weight", "Normal" },
  { "medium_bold"    , "weight", "Medium" },
  { "demi_bold"      , "weight", "DemiBold" },
  { "bold"           , "weight", "Bold" },
  { "extra_bold"     , "weight", "ExtraBold" },
  { "ultra_bold"     , "weight", "Black" },

  { "ultra_condensed", "width", "UltraCondensed"},
  { "extra_condensed", "width", "ExtraCondensed"},
  { "condensed"      , "width", "Condensed"},
  { "semi_condensed" , "width", "SemiCondensed"},
  { "normal_width"   , "width", "NonExpanded"},
  { "semi_expanded"  , "width", "SemiExpanded"},
  { "expanded"       , "width", "Expanded"},
  { "extra_expanded" , "width", "ExtraExpanded"},
  { "ultra_expanded" , "width", "UltraExpanded"},
  { 0, 0, 0 }
  };
  char buf[2000];
  char val[200];
  parse_lcurly(P);
  while(1)
  {
     int i;
     char *kw= parse_ident_or_rcurly(P);
     if (!kw) return ;
     if (!strcmp(kw,"size"))
        { sprintf(buf,"$%s_size", pfx);
          tpl_replace_i(T, buf, parse_int(P)); continue; }
     if (!strcmp(kw,"family"))
        { sprintf(buf,"$%s_family", pfx);
          tpl_replace(T, buf, parse_strlit(P)); continue; }
     for(i=0;font_style_keywords[i][0];i++)
       if (!strcmp(kw,font_style_keywords[i][0]))
       {
        sprintf(buf,"$%s_%s", pfx, font_style_keywords[i][1]);
        sprintf(val,"FXFont::%s", font_style_keywords[i][2]);
        tpl_replace(T, buf, strdup(val));
        break;
       }
     if (!font_style_keywords[i])
       p_error(P,0,"unknown font property '%s'.\n",kw);
  }
}


#line 462 "/home/dodo/SFP/fxform-1.2/src/w_user.u"

static int insert_common_properties(user_widget_t *uw, char *name)
{
  static common_property_t props[]=
  {
#line 490 "/home/dodo/SFP/fxform-1.2/src/w_user.u"

   { "layout", "pack_left", pro_flag},
   { "layout", "pack_right", pro_flag},
   { "layout", "pack_top", pro_flag},
   { "layout", "pack_bottom", pro_flag},
   
   { "layout", "fill_x", pro_flag},
   { "layout", "center_x", pro_flag},
   { "layout", "stick_left", pro_flag},
   { "layout", "stick_right", pro_flag},
   
   { "layout", "fill_y", pro_flag},
   { "layout", "center_y", pro_flag},
   { "layout", "stick_top", pro_flag},
   { "layout", "stick_bottom", pro_flag},

#line 510 "/home/dodo/SFP/fxform-1.2/src/w_user.u"
   { "padding", "pad_left", pro_int },
   { "padding", "pad_right", pro_int },
   { "padding", "pad_top", pro_int },
   { "padding", "pad_bottom", pro_int },

#line 520 "/home/dodo/SFP/fxform-1.2/src/w_user.u"
   { "objid", "objid", pro_ident },

#line 468 "/home/dodo/SFP/fxform-1.2/src/w_user.u"
  { 0, 0 }
  };
  int k=0;
  int i;
  for(i=0;props[i].cls;i++)
    if (!strcmp(name,props[i].cls))
    {
      property_t *P;
      P= malloc(sizeof(*P));
      P->name= props[i].name;
      P->kind= props[i].kind;
      P->next= uw->properties;
      uw->properties= P;
      k++;
    }
  return k;
}

#line 523 "/home/dodo/SFP/fxform-1.2/src/w_user.u"

static void parse_common_properties(user_widget_t *uw, parser_t *P)
{
  char *kw;
  parse_lcurly(P);
  while((kw=parse_ident_or_rcurly(P)))
    if (!insert_common_properties(uw, kw))
      p_error(P,0,"unknown common property '%s'.\n", kw);
}

#line 250 "/home/dodo/SFP/fxform-1.2/src/widget_parser.u"

#line 344 "w_user.c"


tpl_t *define_widget(parser_t *P)
{
   tpl_t *T;
   int have_commands=0;
   user_widget_t *W;
   W= calloc(1,sizeof(*W));
   T= tpl_new(
"\n"
"@library_interface\n"
"\n"
" typedef struct $widget_struct $widget_struct_t;\n"
" typedef struct \n"
" {\n"
"   <command_declarations>\n"
" } $class;\n"
"\n"
" struct $widget_struct {\n"
"   $class *cls;\n"
"   void *widget;\n"
" };\n"
"\n"
"@library_objects\n"
"\n"
"static $class $class_object = {\n"
" <command_assignments>\n"
"};\n"
"\n"
"\n"

   );
      parse_lcurly(P); 
   while(1) {
     char *kw;
     kw= parse_ident_or_rcurly(P);
     if (!kw) break;
 
     if (!strcmp(kw,"property")) { 
          property_t *pro= malloc(sizeof(*pro));
          pro->name= parse_ident(P);
          char *type= parse_ident(P);
          if (!strcmp(type,"int")) pro->kind= pro_int;
          else if (!strcmp(type,"str")) pro->kind= pro_string;
          else if (!strcmp(type,"ident")) pro->kind= pro_ident;
          else if (!strcmp(type,"flag")) pro->kind= pro_flag;
          else if (!strcmp(type,"color")) pro->kind= pro_color;
          else if (!strcmp(type,"font")) pro->kind= pro_font;
          // FIXME: handle the enum case
          else p_error(P,0, "unknown property type '%s'\n", type);
          pro->next= W->properties;
          W->properties= pro;
      continue; }

     if (!strcmp(kw,"name")) {  
        if (W->widget_name) p_error(P,0,"multiple names given for the widget");
        W->widget_name= parse_ident(P);
      continue; }

     if (!strcmp(kw,"library_code")) { 
        if (W->library_code)
         tpl_append(W->library_code, tpl_new(parse_cpp(P)));
        else 
         W->library_code= tpl_new(parse_cpp(P));
      continue; }

     if (!strcmp(kw,"widget_code")) { 
        if (W->widget_code)
          p_error(P,0,"widget code already defined for widget");
        W->widget_code= parse_cpp(P);
      continue; }

     if (!strcmp(kw,"signal")) { 
        signal_t *S;
        S= malloc(sizeof(*S));
        S->name= parse_ident(P);
        S->sel_prefix= parse_ident(P);
        S->next= W->signals;
        W->signals= S;
      continue; }

    if (!strcmp(kw,"command")) {  parse_command(P,T); have_commands=1;  continue; }

    if (!strcmp(kw,"common_properties")) {  parse_common_properties(W, P);  continue; }

   // FIXME: do the common stuff..
       p_error(P,0, "unknown keyword %s.\n",kw);
  }
 

   if (have_commands)
   {
     char g[2000];
     sprintf(g,"gui_%s", W->widget_name);
     tpl_replace(T, "$widget_struct", strdup(g));
     sprintf(g,"gui_%s_t", W->widget_name);
     tpl_replace(T, "$widget_struct_t", strdup(g));
     sprintf(g,"gui_%s_class_t", W->widget_name);
     tpl_replace(T, "$class", strdup(g));
     sprintf(g,"gui_%s_class", W->widget_name);
     tpl_replace(T,"$class_object", strdup(g));

     if (W->library_code) tpl_append(W->library_code, T);
     else W->library_code= T; 
   }


   W->next= user_widgets;
   user_widgets= W;
   return tpl_new("/* no code for user widget class definition */\n");
}

#line 257 "/home/dodo/SFP/fxform-1.2/src/widget_parser.u"

#line 270 "/home/dodo/SFP/fxform-1.2/src/w_user.u"

